-- Craft Research Timer (CRT) by @aTo (EU)
-- v0.4.8

CRT = {
	name = "CraftResearchTimer",
	font = "ZoFontGame",
	cmdsetup = "/crt",
	tic = 1,
	svName = "CraftResearchTimer_SavedVariables",
	svVersion = 0.4,
	font = "ZoFontGame",
	interval = 20,
	width = 100,
	height = 80,
	svDefaults = {
		icon_width = 100,
		icon_height = 80,
		text_width = 200,
		text_height = 80,
		lock = true,
		mode = "Icon",
		timer_format = "smart",
		BS = {
			offset = {
				X = 950,
				Y = 540,
				},
			craft = true,
			Hide_0 = false,
			Hide_Type = "Always",
			BackdropAlpha = 0.5,
			Scale = 1,
			Color = {
				r = 1,
				g = 1,
				b = 1,
				a = 1 },
			},
		CL = {
			offset = {
				X = 1080,
				Y = 540,
				},
			craft = true,
			Hide_0 = false,
			Hide_Type = "Always",
			BackdropAlpha = 0.5,
			Scale = 1,
			Color = {
				r = 1,
				g = 1,
				b = 1,
				a = 1 },
			},
		WO = {
			offset = {
				X = 1210,
				Y = 540,
				},
			craft = true,
			Hide_0 = false,
			Hide_Type = "Always",
			BackdropAlpha = 0.5,
			Scale = 1,
			Color = {
				r = 1,
				g = 1,
				b = 1,
				a = 1 },
			},
		GRID = {
			hidden = false,
			offset = {
				X = 950,
				Y = 400,
				},
			Hide_Type = "Always",
			BackdropAlpha = 0.5,
			Scale = 1,
			Color = {
				r = 1,
				g = 1,
				b = 1,
				a = 1 },
			},
		ALERT = {
			hidden = true,
			preview = false,
			BS = true,
			CL = true,
			WO = true,
			offset = {
				X = 560,
				Y = 100,
				},
			Color = {
				r = 1,
				g = 0,
				b = 0,
				a = 1 },
				
			}
	}
}

CRT.SV={}
CRT_GRID_WD = {}

CRT_CRAFT_TLW = {}
CRT_CRAFT_BD = {}
CRT_CRAFT_WD = {}

function CRT_Init(eventCode, addOnName)

	if(addOnName == CRT.name) then
		CRT.Init_done = false
	
	    -- SavedVariables
	    CRT.SV.Settings = ZO_SavedVars:New(CRT.svName, CRT.svVersion*100, nil, CRT.svDefaults, nil)
	    CRT.SV.Craft_data = ZO_SavedVars:NewAccountWide(CRT.svName, 1, "Craft_data", nil , nil )
	    CRT.SV.Hireling_data = ZO_SavedVars:NewAccountWide(CRT.svName, 1, "Hireling_data", nil , nil )

	    -- Slash commands
	    SLASH_COMMANDS[CRT.cmdsetup] = CRT_CommandText_setup
		
	    -- Create Keybinds
	    ZO_CreateStringId("SI_BINDING_NAME_CRT_ToggleUI", "|c96FF00Toggle craft windows|r")
	    ZO_CreateStringId("SI_BINDING_NAME_CRT_toggleGRID", "|c96FF00Toggle GRID|r")

	    -- options panel
	    local LAM = LibStub:GetLibrary("LibAddonMenu-2.0")

	    local panelData = {
	        type = "panel",
	        name = "Craft Research Timer",
	        displayName = "|c96FF00Craft Research Timer|r Settings"
	    }

		local optionsTable = {

	        -- Main settings
	        {
				type = "header",
				name = "|c96FF00Options|r"
	        }, {
	            type = "checkbox",
	            name = "Unlock all windows",
	            tooltip = "Toggle lock on/off",
	            getFunc = function() return CRT.SV.Settings.lock end,
	            setFunc = CRT_SetLock
	        }, {
	            type = "dropdown",
	            name = "Select Mode",
	            tooltip = "Display researched items as icon or text?",
	            choices = {"Icon", "Text"},
	            getFunc = function() return CRT.SV.Settings.mode end,
	            setFunc = CRT_SetMode,
	            warning = "Will need to reload the UI"
	        }, {
	            type = "dropdown",
	            name = "Timer format",
	            tooltip = "How to display remaining time?",
	            choices = {"smart", "fixed", "compact"},
	            getFunc = CRT_Gettimer_format,
	            setFunc = CRT_Settimer_format,
	        }, {
	            type = "button",
	            name = "Reset to default",
	            tooltip = "Load default values",
	            func = CRT_Reset,
	            warning = "Will need to reload the UI"
	        },

	        -- Alert
	        {
	            type = "header",
	            name = "|c96FF00Alert Components|r"
	        }, {
	            type = "checkbox",
				name = "Enable Alert window",
				tooltip = "Enable Alert window",
				getFunc = function() return CRT.SV.Settings.ALERT.hidden end,
				setFunc = CRT_SetAlert
			}, {
				type = "checkbox",
				name = "Preview Alert window",
				tooltip = "Toggle preview on/off",
				getFunc = function() return CRT.SV.Settings.ALERT.preview end,
				setFunc = CRT_SetPreview
			}, {
				type = "colorpicker",
				name = "Text Color",
				tooltip = "Select the text color",
				getFunc = CRT_GetALERTColor,
				setFunc = CRT_SetALERTColor
			}, {
				type = "checkbox",
				name = "Enable Blacksmithing alert",
				tooltip = "Enable Blacksmithing alert",
				getFunc = function() return CRT.SV.Settings.ALERT.BS end,
				setFunc = CRT_SetALERTBS
			}, {
				type = "checkbox",
				name = "Enable Clothing alert",
				tooltip = "Enable Clothing alert",
				getFunc = function() return CRT.SV.Settings.ALERT.CL end,
				setFunc = CRT_SetALERTCL
			}, {
				type = "checkbox",
				name = "Enable Woodworking alert",
				tooltip = "Enable Woodworking alert",
				getFunc = function() return CRT.SV.Settings.ALERT.WO end,
				setFunc = CRT_SetALERTWO
			},

			-- Grid
			{
				type = "header",
				name = "|c96FF00Grid|r"
			}, {
				type = "slider",
				name = "Alpha",
				tooltip = "Change the transparency of the window",
				min = 0,
				max = 100,
				step = 1,
				getFunc = CRT_GetGRIDBackdropAlpha,
				setFunc = CRT_SetGRIDBackdropAlpha
			}, {
				type = "slider",
				name = "Scale",
				tooltip = "Change the scale of the window",
				min = 0,
				max = 200,
				step = 1,
				getFunc = CRT_GetGRIDScale,
				setFunc = CRT_SetGRIDScale
			}, {
				type = "colorpicker",
				name = "Text Color",
				tooltip = "Select the text color",
				getFunc = CRT_GetGRIDColor,
				setFunc = CRT_SetGRIDColor
			}, {
				type = "button",
				name = "Apply new colors",
				tooltip = "Apply new colors",
				func = function() ReloadUI() end, true,
				warning = "Will reload the UI"
			}, {
				type = "button",
				name = "Toggle grid view",
				tooltip = "Display or hide the grid view",
				func = function() CRT_toggleGRID() end, true,
			},

			--Blacksmithing
			{
				type = "header",
				name = "|c96FF00Blacksmithing Components|r"
			}, {
				type = "checkbox",
				name = "Enable Blacksmithing Tracker",
				tooltip = "Enable Blacksmithing Tracker",
				getFunc = function() return CRT.SV.Settings.BS.craft end,
				setFunc = CRT_SetTrackerBS
			}, {
				type = "checkbox",
				name = "Hide if no research",
				tooltip = "Hide if no research",
				getFunc = function() return CRT.SV.Settings.BS.Hide_0 end,
				setFunc = CRT_SetBSHide0
			}, {
				type = "dropdown",
				name = "Display when",
				tooltip = "Display when",
				choices = {"Always", "Hide in menus","Menus only", "Toggle keybind"},
				getFunc = function() return CRT.SV.Settings.BS.Hide_Type end,
				setFunc = CRT_SetBSHideMenu
			}, {
				type = "slider",
				name = "Alpha",
				tooltip = "Change the transparency of the blacksmithing window",
				min = 0,
				max = 100,
				step = 1,
				getFunc = CRT_GetBSBackdropAlpha,
				setFunc = CRT_SetBSBackdropAlpha
			}, {
				type = "slider",
				name = "Scale",
				tooltip = "Change the scale of the blacksmithing window",
				min = 0,
				max = 200,
				step = 1,
				getFunc = CRT_GetBSScale,
				setFunc = CRT_SetBSScale
			},

			--Clothing
			{
				type = "header",
				name = "|c96FF00Clothing Components|r"
			}, {
				type = "checkbox",
				name = "Enable Clothing Tracker",
				tooltip = "Enable Clothing Tracker",
				getFunc = function() return CRT.SV.Settings.CL.craft end,
				setFunc = CRT_SetTrackerCL
			}, {
				type = "checkbox",
				name = "Hide if no research",
				tooltip = "Hide if no research",
				getFunc = function() return CRT.SV.Settings.CL.Hide_0 end,
				setFunc = CRT_SetCLHide0
			}, {
				type = "dropdown",
				name = "Display when",
				tooltip = "Display when",
				choices = {"Always", "Hide in menus","Menus only", "Toggle keybind"},
				getFunc = function() return CRT.SV.Settings.CL.Hide_Type end,
				setFunc = CRT_SetCLHideMenu
			}, {
				type = "slider",
				name = "Alpha",
				tooltip = "Change the transparency of the clothing window",
				min = 0,
				max = 100,
				step = 1,
				getFunc = CRT_GetCLBackdropAlpha,
				setFunc = CRT_SetCLBackdropAlpha
			}, {
				type = "slider",
				name = "Scale",
				tooltip = "Change the scale of the clothing window",
				min = 0,
				max = 200,
				step = 1,
				getFunc = CRT_GetCLScale,
				setFunc = CRT_SetCLScale
			},

			--Woodworking
			{
				type = "header",
				name = "|c96FF00 Woodworking Components|r"
			}, {
				type = "checkbox",
				name = "Enable Woodworking Tracker",
				tooltip = "Enable Woodworking Tracker",
				getFunc = function() return CRT.SV.Settings.WO.craft end,
				setFunc = CRT_SetTrackerWO
			}, {
				type = "checkbox",
				name = "Hide if no research",
				tooltip = "Hide if no research",
				getFunc = function() return CRT.SV.Settings.WO.Hide_0 end,
				setFunc = CRT_SetWOHide0
			}, {
				type = "dropdown",
				name = "Display when",
				tooltip = "Display when",
				choices = {"Always", "Hide in menus","Menus only", "Toggle keybind"},
				getFunc = function() return CRT.SV.Settings.WO.Hide_Type end,
				setFunc = CRT_SetWOHideMenu
			}, {
				type = "slider",
				name = "Alpha",
				tooltip = "Change the transparency of the woodworking window",
				min = 0,
				max = 100,
				step = 1,
				getFunc = CRT_GetWOBackdropAlpha,
				setFunc = CRT_SetWOBackdropAlpha
			}, {
				type = "slider",
				name = "Scale",
				tooltip = "Change the scale of the woodworking window",
				min = 0,
				max = 200,
				step = 1,
				getFunc = CRT_GetWOScale,
				setFunc = CRT_SetWOScale
			}

		}
		LAM:RegisterAddonPanel("CRT_OptionsPanel", panelData);
		LAM:RegisterOptionControls("CRT_OptionsPanel", optionsTable);

		CRT_Current_Playername = GetUnitName("player")
		CRT_Start_PlayerPosition = GetMapPlayerPosition("player")
		local timestamp = GetTimeStamp()

		CRT_Alert_Create()

		-- check if old alert before erase data
		--CRT_Alert_Check(playername,timestamp)

		-- erase data for this character
		CRT.SV.Craft_data[CRT_Current_Playername] = {}
		CRT.SV.Craft_data[CRT_Current_Playername]["Start"] = true
		-- collect data
		CRT_Collect_Data(CRT_Current_Playername)

		-- Create GRID
		CRT_GRID_Create()
		-- Create SOLO CRAFT
		CRT_CRAFT_Create()
		CRT.Init_done = true
	end
end

function CRT_Update()
	if not CRT.Init_done then return; end
	if not BufferReached("Info_Research", CRT.tic)  then return; end
	local timestamp = GetTimeStamp()
	CRT_ALERT_Update(timestamp)
	CRT_GRID_Update(timestamp)
	CRT_CRAFT_Update(timestamp)
	CRT_toggleGUI()
end

local bt= {}
function BufferReached( BufferName, ThrottleInSeconds )
		if not BufferName then return end
		local ct, ThrottleInSeconds = GetGameTimeMilliseconds(), ((ThrottleInSeconds or 3) * 1000)
		--d("start:"..start.. "test "..ThrottleInSeconds )
		if not bt[BufferName] then bt[BufferName] = ct end
		if (ct - bt[BufferName]) >= ThrottleInSeconds
		then bt[BufferName] = ct; return true;
		else return false; end
end

local btwait = {}
function BufferWait(BufferName, WaitTime)
	if (btwait["BufferName"] ~= nil and GetGameTimeMilliseconds() < btwait["BufferName"]) then
		d("false")
		return false
	else
		btwait["BufferName"] = GetGameTimeMilliseconds() + (WaitTime * 1000)
		d("true")
		return true
	end
end


EVENT_MANAGER:RegisterForEvent(CRT.name, EVENT_ADD_ON_LOADED, CRT_Init)
EVENT_MANAGER:RegisterForEvent(CRT.name, EVENT_SMITHING_TRAIT_RESEARCH_STARTED, CRT_Research_started)
--EVENT_MANAGER:RegisterForEvent(CRT.name, EVENT_MAIL_OPEN_MAILBOX, CRT_Force_read)
--EVENT_MANAGER:RegisterForEvent(CRT.name, EVENT_MAIL_NUM_UNREAD_CHANGED, CRT_mail_check)




function CRT_ToggleUI()
	if (CRT.SV.Settings.BS.craft == true and CRT.SV.Settings.BS.Hide_Type == "Toggle keybind") then
		if (CRT_CRAFT_TLW[0]:IsHidden() == true) then
			CRT_CRAFT_TLW[0]:SetHidden(false)
		else
			CRT_CRAFT_TLW[0]:SetHidden(true)
		end
	end
	if (CRT.SV.Settings.CL.craft == true and CRT.SV.Settings.CL.Hide_Type == "Toggle keybind") then
			if (CRT_CRAFT_TLW[1]:IsHidden() == true) then
			CRT_CRAFT_TLW[1]:SetHidden(false)
			else
			CRT_CRAFT_TLW[1]:SetHidden(true)
			end
	end
	if (CRT.SV.Settings.WO.craft == true and CRT.SV.Settings.WO.Hide_Type == "Toggle keybind") then
			if (CRT_CRAFT_TLW[2]:IsHidden() == true) then
			CRT_CRAFT_TLW[2]:SetHidden(false)
			else
			CRT_CRAFT_TLW[2]:SetHidden(true)
			end
	end
end

function CRT_toggleGRID()
			if (CRT_GRID_TLW:IsHidden() == true) then
			CRT_GRID_TLW:SetHidden(false)
			CRT.SV.Settings.GRID.hidden = false
			else
			CRT_GRID_TLW:SetHidden(true)
			CRT.SV.Settings.GRID.hidden = true
			end
end

function CRT_toggleGUI()

			local checkUI = ZO_Compass:IsHidden()
			local hidemenu ={}
			hidemenu[0] = CRT.SV.Settings.BS.Hide_Type
			hidemenu[1] = CRT.SV.Settings.CL.Hide_Type
			hidemenu[2] = CRT.SV.Settings.WO.Hide_Type


	for id_craft = 0, 2 , 1 do
		if ((id_craft == 0 and CRT.SV.Settings.BS.craft == true) or (id_craft == 1 and CRT.SV.Settings.CL.craft == true) or (id_craft == 2 and CRT.SV.Settings.WO.craft == true)) then
			if (hidemenu[id_craft] ~= "Toggle keybind") then
				if (hidemenu[id_craft] == "Hide in menus" and checkUI == true)then
					CRT_CRAFT_TLW[id_craft]:SetHidden(true)
				elseif (hidemenu[id_craft] == "Hide in menus" and checkUI == false)then
					CRT_CRAFT_TLW[id_craft]:SetHidden(false)
				elseif (hidemenu[id_craft] == "Menus only" and checkUI == true) then
					CRT_CRAFT_TLW[id_craft]:SetHidden(false)
				elseif (hidemenu[id_craft] == "Menus only" and checkUI == false) then
					CRT_CRAFT_TLW[id_craft]:SetHidden(true)
				elseif (hidemenu[id_craft] == "Always") then
					CRT_CRAFT_TLW[id_craft]:SetHidden(false)
				end
			end
		end
		
		local hide0 ={}
		hide0[0] = CRT.SV.Settings.BS.Hide_0
		hide0[1] = CRT.SV.Settings.CL.Hide_0
		hide0[2] = CRT.SV.Settings.WO.Hide_0
		
		
		if (hide0[id_craft] == true and hidemenu[id_craft] ~= "Toggle keybind" and CRT.SV.Craft_data[CRT_Current_Playername][id_craft]["Simu_craft"] == 0) then
			CRT_CRAFT_TLW[id_craft]:SetHidden(true)
		end
	end
end

function CRT_Converthms(timesec)

    local showDays = false
    local showSeconds = false

    local days = 0
    local hours = 0
    local minutes = 0
    local seconds = 0

    local function extractIntegerUnits(sec, unitduration)
        local units = math.floor(sec / unitduration)
        return units, sec - (units * unitduration)
    end

    local format = CRT.SV.Settings.timer_format
    if ((format ~= "fixed") and (format ~= "compact")) then
        format = "smart"
    end

    if (format == "smart") then
        days, timesec = extractIntegerUnits(timesec, 60*60*24)
    end
    hours, timesec = extractIntegerUnits(timesec, 60*60)
    minutes, seconds = extractIntegerUnits(timesec, 60)

    local humanDuration
    if (format == "smart") then
        humanDuration = string.format("%d:%02d", hours, minutes)
        if (days > 0) then
            humanDuration = string.format("%dd ", days)..humanDuration
        end
    else
        humanDuration = string.format("%02d:%02d", hours, minutes)
        if (format == "fixed") then
            humanDuration = humanDuration..(string.format(":%02d", seconds))
        end
    end

    return humanDuration

end

    function pairsByKeys (t, f)
      local a = {}
      for n in pairs(t) do table.insert(a, n) end
      table.sort(a, f)
      local i = 0      -- iterator variable
      local iter = function ()   -- iterator function
        i = i + 1
        if a[i] == nil then return nil
        else return a[i], t[a[i]]
        end
      end
      return iter
    end
	

function CRT_Save_position(id_craft)
	if (id_craft == 0) then
		CRT.SV.Settings.BS.offset.X = math.floor(CRT_CRAFT_TLW[id_craft]:GetLeft())
		CRT.SV.Settings.BS.offset.Y = math.floor(CRT_CRAFT_TLW[id_craft]:GetTop())
	elseif (id_craft == 1) then
		CRT.SV.Settings.CL.offset.X = math.floor(CRT_CRAFT_TLW[id_craft]:GetLeft())
		CRT.SV.Settings.CL.offset.Y = math.floor(CRT_CRAFT_TLW[id_craft]:GetTop())
	elseif (id_craft == 2) then
		CRT.SV.Settings.WO.offset.X = math.floor(CRT_CRAFT_TLW[id_craft]:GetLeft())
		CRT.SV.Settings.WO.offset.Y = math.floor(CRT_CRAFT_TLW[id_craft]:GetTop())
	elseif (id_craft == "GRID") then
		CRT.SV.Settings.GRID.offset.X = math.floor(CRT_GRID_TLW:GetLeft())
		CRT.SV.Settings.GRID.offset.Y = math.floor(CRT_GRID_TLW:GetTop())
	elseif (id_craft == "ALERT") then
		CRT.SV.Settings.ALERT.offset.X = math.floor(CRT_ALERT_TLW:GetLeft())
		CRT.SV.Settings.ALERT.offset.Y = math.floor(CRT_ALERT_TLW:GetTop())
	end 
end



function CRT_CommandText_setup(lparam)
	if (lparam == "info") then 
		d("Craft Research Timer (CRT) by @aTo (EU)")
		d("Version 0.4.8")
		d("The CRT have moved to the normal game settings")
	elseif (lparam == "grid") then
		CRT_toggleGRID()
	else
		CRT_ToggleUI()
	end
end

